#pragma once

#include <PubSub.h>
#include "../../Platform.h"
#include "../../Constants/Module.h"
#include "../../Models/Message.h"
#include "../ModuleBase.h"
#include "SerialPort.h"

namespace mas
{
  class SerialModule : public ModuleBase
  {
  public:

    // The minimum baud rate will be determined by the volume of Waveform data generated by the Audio Analyzer, as it
    // will require transmitting the most substantial amount of data.
    //
    // Waveform data is sent in the format:
    //
    //   [AWA] <base64-data>
    //
    // If we assume that:
    // - our max transmitted message size is 64 characters including a null terminator (see SerialisationHelper.h)
    // - We allow for a maximum of 30 FPS (Note: the 256x64px OLED struggles to refresh a full screen faster than 10fps)
    // - 16-bit Waveform data is reduced to 6-bits, which can be represended by a single base64 symbol per sample
    // - The max display width will be 256 px. Displaying one pixel per sample
    // - Our UART connection uses 9 bits per byte (using the default of 8 data bits, no parity, and one stop bit)
    //
    // Our minimum baud rate can be calculated as:
    //
    //    minimum baud rate = MAX_TRANSMITTED_MESSAGE_SIZE x FPS x BITS_PER_BYTE
    //                      = 64 x 30 x 9
    //                      = 17,280
    //
    // Let's just round up to the closet common rate, which also gives us extra room for messages between other modules.
    //
    // Note: we can go much higher if we keep the baud rate as a divisor of the clock speeds (i.e.: 600 MHz and 16 MHz).
    // 2,000,000 baud is achievable without issues on a 16 Mhz ATMEGA1284, but we'll very quickly fill the RX buffer
    // while performing blocking operations like drawing the display etc.
    //
    // TODO:  Implement custom hardware serial with larger RX buffer than the default 64 bytes.
    //        It may simply be a case of modifying the existing HardwareSerial's .begin() function to take a buffer.
    //
    //        We're trying to solve a problem where we're filling the buffer while making a blocking call to render the
    //        display, which can take up to 300ms for a full frame of text.
    //
    //        This may take a combination of increasiing the RX buffer, and optimising the render function to take less
    //        time.
    //
    //        Unfortunatley, SH1122 does NOT support updateDisplayArea due to the different low level byte output
    //        strategy. See https://github.com/olikraus/u8g2/wiki/u8g2reference#updatedisplayarea
    //
    static const uint32_t BAUD_RATE = 115200;

    SerialModule(Broker<Message *> & broker, char* const errorBuffer, SerialPort * ports, const size_t count);
    void begin();
    void loop();
    void notify(Message * pMessage);
  
  private:
    SerialPort *_ports;
    size_t _count;    
  };
}
